var detailsHeight;
var detailsMaxHeight;
var itemsMaxWidth;
var selectedItemType = 0;
var selectedItem;
var longDescriptionTarget = "%longDescriptionTarget%";
var showSuperclassAttributes = ("%showSuperclassAttributes%" == "TRUE");
var showCountsAttribute = ("%showCounts%" == "TRUE");
var isCancelled = 'true';
var arrayObject;
isPremiumPlaceholder;

var transformMatrix = [[1, 0, 0, 1, 0, 0], [1, 0, 0, 1, 0, 0]];
var centerX = [];
var centerY = [];
var matrixGroup = [];

var issueType = "Issue Report";
var sliderValue = [20,20];

// drag:1, crop:2
var mouseMoveSelect = 0;

// crop
var isCropped = false;
var showCrop = [0,0];
var cropStartMousePos = {};
var oldX, oldY;
var cropAction;
var rectWidth;
var rectHeight;
var initScale = 1;
var scaleFactor = [initScale,initScale];
circlesRadiusConstant = 7;
rectWidthConstant = 260;
rectHeightConstant = 130;
rectXConstant = 230;
rectYConstant = 70;

var circlesRadius = [circlesRadiusConstant, circlesRadiusConstant];

// drag
var transformsArray = [];
var transform2 = [];
var offset = [];
var currentManif = [-1,-1];
var currentSourceManif = [-1,-1];

$( function() {
	$( "#mainmenu" ).menu({
		select: function( event, ui ) {
			if (ui.item.text() == 'Settings') {
				settings();
			} else if (ui.item.text() == 'About') {
				about();
			} else if (ui.item.text() == 'Compare') {
				compare(event);
			} else if (ui.item.text() == 'Issue Report') {
				issueType = 'Issue Report';
				errorReport(event);
			} executionsPlaceholder	
		}
	});
	
	$( "#z01s" ).slider({
		min: 1,
		max: 40,
		value: sliderValue[0],
		slide: function( event, ui ) {
			if(ui.value > sliderValue[0]) {
				factor =  Math.pow(1.0525, ui.value - sliderValue[0]);
			} else if(ui.value < sliderValue[0]) {
				factor = Math.pow(0.95, sliderValue[0] - ui.value);
			}
			zoom(0, factor, true);
			sliderValue[0] = ui.value;
      	}
	});
	
	$( "#z02s" ).slider({
		min: 1,
		max: 40,
		value: sliderValue[1],
		slide: function( event, ui ) {
			if(ui.value > sliderValue[1]) {
				factor =  Math.pow(1.0525, ui.value - sliderValue[1]);
			} else if(ui.value < sliderValue[1]) {
				factor = Math.pow(0.95, sliderValue[1] - ui.value);
			}
			zoom(1, factor, true);
			sliderValue[1] = ui.value;
      	}
	});
	
} );

function compare(event) {
	panel = (event.altKey ? 2 : 1);
	$("#panel" + panel).html(toCompareDetails(currentRun));
	$("#panel" + panel + "Strong").text("Compare");
	$("#panel" + panel + "HeaderImage").attr("src", "resources/compare.png");
	$(".itemsContent").html('');
}

function errorReport(event) {
	panel = (event.altKey ? 2 : 1);
	$("#panel" + panel).html( toHtmlErrorDetails(currentRun, issueType) );
	$("#panel" + panel + "Strong").text(issueType);
	$("#panel" + panel + "HeaderImage").attr("src", "resources/text.png");
	$(".itemsContent").html('');
}

function about() {
	$("#aboutPopup").dialog({
		draggable: true,
		resizable: false
	});
}

function settings() {
	isCancelled = 'true';
	$("#settingsPopup").dialog({
		width: 450,
		draggable: true,
		resizable: false,
		close: function() {
			if (isCancelled == 'true') {
				$("#showD-" + longDescriptionTarget).prop("checked", true);
				$("#showSuper").prop("checked", showSuperclassAttributes);
				$("#showCounts").prop("checked", showCountsAttribute);
			} 
		},
		buttons: [
   			{
   				text: "Ok",
   				click: function() {
					isCancelled = 'false';
					var radioValue1 = $("input[name='showLoDescr']:checked").val();
					longDescriptionTarget = radioValue1;
					
					var radioValue2 = $("input[name='showSuper']:checked").val();
					if(radioValue2){
						showSuperclassAttributes = true;
					} else {
						showSuperclassAttributes = false;
					}
					showOrHideSuperclasses();

					var radioValue3 = $("input[name='showCounts']:checked").val();
					if(radioValue3){
						showCountsAttribute = true;
						$(".showCounts").show();
					} else {
						showCountsAttribute = false;
						$(".showCounts").hide();
					}

       				$( this ).dialog( "close" );
   				},
   			},
   			{
   				text: "Cancel",
   				click: function() {
   					$("#showD-" + longDescriptionTarget).prop("checked", true);
					$("#showSuper").prop("checked", showSuperclassAttributes);
					$("#showCounts").prop("checked", showCountsAttribute);
       				$( this ).dialog( "close" );
   				}
   			}
		]
	});
}

if (typeof(isPremium) != 'undefined') {
	$( function() {
	  $.widget( "custom.catcomplete", $.ui.autocomplete, {
	    _create: function() {
	      this._super();
	      this.widget().menu( "option", "items", "> :not(.ui-autocomplete-category)" );
	    },
		_renderItem: function( ul, item ) {
			return $( "<li>" )
				.append( $( "<div>" ).text( item.lb ) )
				.appendTo( ul );
		},
	    _renderMenu: function( ul, items ) {
	      var that = this,
	        currentCategory = "";
	      $.each( items, function( index, item ) {
	        var li;
			typ = "Class Attributes";
			if(item.ty =='J') {
				typ = 'Classes';
			} else if(item.ty =='T') {
				typ = 'Tables';
			} else if(item.ty =='C') {
				typ = 'Columns';
			} else if(item.ty =='F') {
				typ = 'Constraints';
			} else if(item.ty =='I') {
				typ = 'Indexes';
			} else if(item.ty =='S') {
				typ = 'Sequences';
			} else if(item.ty =='G') {
				typ = 'ID Generators';
			}
		
	        if ( typ != currentCategory ) {
	          ul.append( "<li class='ui-autocomplete-category'>" + typ + "</li>" );
	          currentCategory = typ;
	        }
	        li = that._renderItemData( ul, item );
	        if ( typ ) {
	          li.attr( "aria-label", typ + " : " + item.lb );
	        }
	      });
	    }
	  });

	  $.ui.autocomplete.filter = function (array, term) {
		var matcher = new RegExp( $.ui.autocomplete.escapeRegex( term ), "i" );
		return $.grep( array, function( value ) {
			pos = value.lb.indexOf("(");
			name = value.lb;
			if(pos > 0) {
				name = value.lb.substring(0, pos);	
			}
			return matcher.test( name || value.value || value );
		} );
	  };

	  $( "#search" ).catcomplete({
	    delay: 0,
	    source: APP[currentRun].si,
	     select: function( event, ui ) {
			hc = ui.item.hc;
			typ = ui.item.ty; 
			panel = (event.altKey ? 2 : 1);
		
			if(typ == 'J' || typ == 'A') {
				currentDetailsDiv = '#de-it-jp-' + hc;
				$("#panel" + panel).html( toHtmlJpaDetails(hc, panel, currentRun) );
				showOrHideSuperclasses();
				
			} else if(typ == 'S') {
				currentDetailsDiv = '#de-it-seq-' + hc;
				$("#panel" + panel).html( toHtmlSeqDetails(hc, currentRun) );
			} else if(typ == 'G') {
				currentDetailsDiv = '#de-it-ge-' + hc;
				$("#panel" + panel).html( toHtmlGeDetails(hc, currentRun) );
			} else {
				currentDetailsDiv = '#de-it-db-' + hc;
				$("#panel" + panel).html( toHtmlDbDetails(hc, currentRun) );
			}
	
			text = ui.item.lb;
			index = text.lastIndexOf(".");
			if(index > 0) {
				text = text.substring(index+1);
			}
		
			$("#panel" + panel + "Strong").text(text);
			if (currentDetailsDiv.indexOf("de-it-jp") > 0 || currentDetailsDiv.indexOf("de-it-ge") > 0) {
				$("#panel" + panel + "HeaderImage").attr("src", "resources/java.png");
			} else {
				$("#panel" + panel + "HeaderImage").attr("src", "resources/db.png");
			}
	
			$(this).val('');
	        return false;
	     }
	  });
	} );
}

function scrollPart(panel) {
	scrollLeft = panel.scrollLeft();
	scrollWidth = panel.get(0).scrollWidth;
	outerWidth = panel.outerWidth();
	xmiddle = (scrollWidth - outerWidth + 17) / 2;
	xscroll = xmiddle - scrollLeft;
	
	scrollTop = panel.scrollTop();	
	scrollHeight = panel.get(0).scrollHeight;
	outerHeight = panel.outerHeight();
	ymiddle = (scrollHeight - outerHeight + 17) / 2;
	yscroll = ymiddle - scrollTop;
	
	return {x:xscroll, y: yscroll};
}

function zoom(k, scale, withTranslate) {
	for (var i = 0; i < transformMatrix[k].length; i++) {
    	transformMatrix[k][i] *= scale;
	}

	scrolling = {x:0 , y:0};
	translate = "";
	oldtrans = matrixGroup[k].attr("transform");
	if(oldtrans && withTranslate) {
		translate = oldtrans.substring(0, oldtrans.indexOf("matrix")).trim();

		if(translate) {
			scrolling = scrollPart($("#panel" + (k+1)));
			
			transx = 0;
			transy = 0;
			// translate == translate(0) or translate(0 0)
			pos1 = translate.indexOf("(");
			if(pos1 > 0) {
				translate2 = translate.substring(pos1 + 1, translate.length - 1);
				pos2 = translate2.indexOf(" ");
				if(pos2 > 0) {
					transx = scale * parseInt(translate2.substring(0, pos2).trim());
					transy = scale * parseInt(translate2.substring(pos2).trim());
				} else {
					transx= scale * parseInt(translate2.trim());
				}
				
				translate = "translate(" + transx + " " + transy + ")";
			}
		}
	}

    transformMatrix[k][4] += (1 - scale) * (centerX[k] - scrolling.x);
    transformMatrix[k][5] += (1 - scale) * (centerY[k] - scrolling.y);
            
    var newMatrix = translate + " matrix(" +  transformMatrix[k].join(' ') + ")";
	matrixGroup[k].attr("transform", newMatrix);
	
	panel = k + 1;
	if ( $("#panel" + panel + " svg").attr("id").startsWith("cropped") ) {
		rex = parseFloat( $("#panel" + panel + " defs rect").attr("x") );
		rex *= scale;
		rex += (1 - scale) * (centerX[k] - scrolling.x); 	
	
		rey = parseFloat( $("#panel" + panel + " defs rect").attr("y") );
		rey *= scale;
		rey += (1 - scale) * (centerY[k] - scrolling.y); 	

		x2 = parseFloat( $("#panel" + panel + " defs rect").attr("height") );
		x3 = parseFloat( $("#panel" + panel + " defs rect").attr("width") );

		$("#panel" + panel + " defs rect").attr("x", rex);
		$("#panel" + panel + " defs rect").attr("y", rey);
		$("#panel" + panel + " defs rect").attr("width", x3 * scale);
		$("#panel" + panel + " defs rect").attr("height", x2 * scale);

		$("#panel" + panel + " .croppedRect").attr("x", rex);
		$("#panel" + panel + " .croppedRect").attr("y", rey);
		$("#panel" + panel + " .croppedRect").attr("width", x3 * scale);
		$("#panel" + panel + " .croppedRect").attr("height", x2 * scale);
		$("#panel" + panel + " .croppedRect").show();
	}
}

function initDraggable(panel) {
	svg = $("#panel" + panel + " svg")[0];
	g = $("#panel" + panel + " .draggable")[0];
	
	transformsArray[panel - 1] = g.transform.baseVal;
	
    if (transformsArray[panel - 1].length === 0 || transformsArray[panel - 1].getItem(0).type !== SVGTransform.SVG_TRANSFORM_TRANSLATE) {
		// Create an transform that translates by (0, 0)
    	var translate = svg.createSVGTransform();
    	translate.setTranslate(0, 0);
    	g.transform.baseVal.insertItemBefore(translate, 0);
    }

	svg.addEventListener("mousedown",function(evt){
		startDrag(evt, panel);	
	}, false);

	svg.addEventListener("dblclick",function(evt){
		moveLoupe(evt, panel);	
	}, false);
	
}

function drag(evt, panel) {
	if (mouseMoveSelect == 1) {
    	evt.preventDefault();
    	var coord = getMousePosition(evt);
        transform2[panel - 1].setTranslate(coord.x - offset[panel - 1].x, coord.y - offset[panel - 1].y);
	}
}

function startDrag(evt, panel) {
	if(mouseMoveSelect > 1) return;
	mouseMoveSelect = 1;
	
	transform2[panel - 1] = transformsArray[panel - 1].getItem(0);

    // Get initial translation
	offset[panel - 1] = getMousePosition(evt);
    offset[panel - 1].x -= transform2[panel - 1].matrix.e;
    offset[panel - 1].y -= transform2[panel - 1].matrix.f;
}

function getMousePosition(evt) {
	var CTM = svg.getScreenCTM();
    if (evt.touches) { evt = evt.touches[0]; }
    return {
       x: (evt.clientX - CTM.e) / CTM.a,
       y: (evt.clientY - CTM.f) / CTM.d
    };
}

// workaround because svg.attr("viewBox") does not work, dont know why
function getAttribute ( $node, name ) {
	var avalue;
    $.each( $node[0].attributes, function ( index, attribute ) {
		if(attribute.name == name){
			avalue = attribute.value;
		}
    } );
	return avalue;
}

function initSvg(panel) {
	transformMatrix[panel-1] = [1, 0, 0, 1, 0, 0];

	svg = $("#panel" + panel + " svg");
	x1 = parseInt( $("#panel" + panel).css("width").slice(0, -2) );
	x2 = parseInt( svg.attr("width").slice(0, -2) );
	
	if (x2 < x1) {
		x3 = parseInt( svg.attr("height").slice(0, -2) );
		newHeight = parseInt( x1/x2 * x3 );
		
		svg.attr("width", x1 + 'px');
		svg.attr("height", newHeight + 'px');
		svg.css("width", x1 + 'px');
		svg.css("height", newHeight + 'px');
		x2 = parseInt( svg.attr("width").slice(0, -2) );
	}
		
    viewbox = getAttribute(svg, "viewBox").split(" ");
    centerX[panel-1] = parseFloat(viewbox[2]) / 2;
    centerY[panel-1] = parseFloat(viewbox[3]) / 2;
    matrixGroup[panel-1] = $("#panel" + panel + " svg .draggable");
	zoom(panel-1, x1/x2, false);
	initDraggable(panel);

	if (typeof(isPremium) != 'undefined') {
		isCropped = false;
		panelid = $("#panel" + panel).parents("div.colElem:first").attr("id");
		circlesRadius[panel-1] = circlesRadiusConstant;
		scaleFactor[panel-1] = initScale;
		hideRect(panel-1, panelid);
		cropReset(panel);
	}
}

function croppedInit(panel, targetPanel) {
	transformMatrix[targetPanel-1] = [...transformMatrix[panel-1]];
	x1 = parseInt( $("#panel" + panel).css("height").slice(0, -2) );
	x2 = parseInt( $("#panel" + panel + " defs rect").attr("height") );
	
	matrixGroup[targetPanel-1] = $("#panel" + targetPanel + " svg .draggable");
	
    centerX[targetPanel-1] = centerX[panel-1];
    centerY[targetPanel-1] = centerY[panel-1];
	
	scale = x1/x2;
	zoom(targetPanel-1, scale, true);
}

function init() {
	$("#panel2").html(toApplicationDetails(currentRun));
	$("#panel2Strong").text("Application " + APP[currentRun].name);
	
	$("#panel1").html(toDatabaseDetails(currentRun));
	$("#panel1Strong").text("Database " + APP[currentRun].name);
	$("#panel1HeaderImage").attr("src", "resources/db.png");
	
	$("#runRefName").html(APP[currentRun].name);
	$("#runCreateDate").html(APP[currentRun].da);
	toHtmlListings(currentRun);
	if(selectedItemType != 0) {
		selectedItemType.toggleClass("active");
	}
	selectedItemType = $("#t-database");
	selectedItemType.toggleClass("active");
	$(".itemsContent").html('');

	if (typeof(isPremium) != 'undefined') {
		$( "#search" ).catcomplete("option", "source", APP[currentRun].si);
	}
}

function showOrHideSuperclasses() {
	if (showSuperclassAttributes == false) {
		$(".superClass").hide();
		$(".hide-superClass").hide();
	} else {
		$(".superClass").show();
		$(".hide-superClass").show();
	}
}

function db2jpalinkMultiple(arrObj, panel) {
	// check if panel contains a mapped or associated class
	title = $("#panel" + panel + "Strong").text();
	img = $("#panel" + panel + "HeaderImage").attr("src"); 	
	
	list = '<input type="hidden" id="notLinkedPopupType" value="jpa">';
	panelContains = false;
	var theobj;
	for(let obj of arrObj) {
		hc = hashId(obj.id);		
		jpa = MAP[currentRun]['jp' + hc][0];
		list += '<li><a class="link dialink" data-dialink="' + obj.id + '">' + jpa.na + '</a></li>';
		
		if(jpa.ty == 'EMBEDDABLE') {
			panelContains = true;
			theobj = obj;
			break;
		}
		
		if(jpa.na.indexOf(title) > 0
			&& img == 'resources/java.png'
			&& $("#panel" + panel).html().indexOf(jpa.na) > 0) {
			panelContains = true;
			theobj = obj;
			break;
		}
	}

	if(panelContains == false) {
		text = $("#notLinkedPopup").html();
		pos1 = text.indexOf('<ul>') + 4;
		pos2 = text.indexOf('</ul>');				
		newtext = text.replace(text.slice(pos1, pos2), list)
		$("#notLinkedPopup").html(newtext);
		
		$("#notLinkedPopup > #panelnbr").remove();
		$("#notLinkedPopup").append('<div id="panelnbr" data-id="' + panel + '"></div>');
		
		$( "#notLinkedPopup" ).dialog({ 
			autoOpen: true, 
			width: 500
		});
		return;
	}
		
	highlightJpa(theobj, theobj.li[0].ci, panel);
}

function highlightJpa(obj, id, panel) {
	$("#panel" + panel).html( toHtmlJpaDetails(id, panel, currentRun) );
	$(".plusminus").click();

	temp = showSuperclassAttributes;
	showSuperclassAttributes = true;
	showOrHideSuperclasses();

	var str = "";
	if(activeTab != -1) {
		str = '#tabs-' + activeTab + ' ';
	}
		
	for (i = 0; i < obj.li.length; i++) {
		var elem = $(str + "." + obj.li[i].ai);
		//alert(elem.prop('tagName'));
		
		elem.toggleClass("linked");
		elem.toggleClass("gradient");
	}
		
	hc = hashId(id);
	db = MAP[currentRun]['jp' + hc][0];
	$("#panel" + panel + "Strong").text( shortName(db.na) );
	$("#panel" + panel + "HeaderImage").attr("src", "resources/java.png");

	$('#panel' + panel).animate({
   		scrollTop: $(str + "." + obj.li[0].ai).offset().top - $('#panel' + panel).offset().top + $('#panel' + panel).scrollTop()
	}, 'fast');

	showSuperclassAttributes = temp;
}

function db2domlinkMultiple(arrObj, panel) {
	// check if target panel contains a mapped or associated class
	title = $("#panel" + panel + "Strong").text();
	img = $("#panel" + panel + "HeaderImage").attr("src"); 	
	
	list = '<input type="hidden" id="notLinkedPopupType" value="dom">';
	panelContains = false;
	var theobj;
	for(let obj of arrObj) {
		hc = hashId(obj.id);		
		jpa = MAP[currentRun]['jp' + hc][0];
		name = shortName(jpa.na).toUpperCase();
		list += '<li><a class="link dialink" data-dialink="' + obj.id + '">' + name + '</a></li>';
		
		if(name == title
			&& img == 'resources/business.png'
			&& $("#panel" + panel).html().indexOf(name) > 0) {
			panelContains = true;
			theobj = obj;
			break;
		}
	}

	if(panelContains == false) {
		text = $("#notLinkedPopup").html();
		pos1 = text.indexOf('<ul>') + 4;
		pos2 = text.indexOf('</ul>');				
		newtext = text.replace(text.slice(pos1, pos2), list)
		$("#notLinkedPopup").html(newtext);

		$("#notLinkedPopup > #panelnbr").remove();
		$("#notLinkedPopup").append('<div id="panelnbr" data-id="' + panel + '"></div>');
		
		$( "#notLinkedPopup" ).dialog({ 
			autoOpen: true, 
			width: 500
		});
		return;
	}
		
	highlightDom(theobj, theobj.li[0].ci, panel);
}

function highlightDom(obj, id, panel) {
	$("#panel" + panel).html( toHtmlDoDetails(id, currentRun) );

	for (i = 0; i < obj.li.length; i++) {
		var elem = $("." + obj.li[i].ai);
		elem.toggleClass("linked");
		elem.toggleClass("gradient");
	}
		
	hc = hashId(id);
	jpa = MAP[currentRun]['jp' + hc][0];
	$("#panel" + panel + "Strong").text( shortName(jpa.na.toUpperCase()) );
	$("#panel" + panel + "HeaderImage").attr("src", "resources/business.png");

	$('#panel' + panel).animate({
   		scrollTop: $("." + obj.li[0].ai).offset().top - $('#panel' + panel).offset().top + $('#panel' + panel).scrollTop()
	}, 'fast');
}

function linkIt(thiss, panel, currentDetailsDiv) {
	if (currentDetailsDiv.indexOf("de-it-pu-") > 0 ) {
		key = currentDetailsDiv.substring("de-it-pu-".length + 1);
	 	$("#panel" + panel).html( toHtmlPuDetails(key, currentRun) );
		
	} else if (currentDetailsDiv.indexOf("de-it-do-") > 0 ) {
		key = currentDetailsDiv.substring("de-it-do-".length + 1);
	 	$("#panel" + panel).html( toHtmlDoDetails(key, currentRun) );

	} else if (currentDetailsDiv.indexOf("de-it-dd-") > 0 ) {
		key = currentDetailsDiv.substring("de-it-dd-".length + 1);
		$("#panel" + panel).html( toHtmlDomainDetails(key, currentRun) );
		
	} else if (currentDetailsDiv.indexOf("de-it-db-") > 0 ) {
		key = currentDetailsDiv.substring("de-it-db-".length + 1);
	 	$("#panel" + panel).html( toHtmlDbDetails(key, currentRun) );
		
	} else if (currentDetailsDiv.indexOf("de-it-seq-") > 0 ) {
		key = currentDetailsDiv.substring("de-it-seq-".length + 1);
	 	$("#panel" + panel).html( toHtmlSeqDetails(key, currentRun) );

	} else if (currentDetailsDiv.indexOf("de-it-ge-") > 0 ) {
		key = currentDetailsDiv.substring("de-it-ge-".length + 1);
	 	$("#panel" + panel).html( toHtmlGeDetails(key, currentRun) );
		
	} else if (currentDetailsDiv.indexOf("de-it-jp-") > 0 ) {
		key = currentDetailsDiv.substring("de-it-jp-".length + 1);
	 	$("#panel" + panel).html( toHtmlJpaDetails(key, panel, currentRun) );
		showOrHideSuperclasses();
	} else if (currentDetailsDiv.indexOf("de-it-di-") > 0 ) {
		key = currentDetailsDiv.substring("de-it-di-".length + 1);
	 	$("#panel" + panel).html( SVG[currentRun][key] );
		initSvg(panel);
		scrollToMiddle("panel" + panel);
	} else if (currentDetailsDiv.indexOf("de-it-man-") > 0 ) {
		key = currentDetailsDiv.substring("de-it-man-".length + 1);
		panel = thiss.parents('.content').attr('id');
		$("#" + panel + " .manifest").html( toManifestDetails(key, thiss.attr("data-id2"), currentRun) );
		return;
	} else if (currentDetailsDiv.indexOf("de-it-depman-") > 0 ) {
		panel = thiss.parents('.content').attr('id');
		panelId = panel.substring(5);
		curRow = currentDetailsDiv.substring("de-it-depman-".length + 1);
		if(currentManif[panelId] != -1 && currentManif[panelId] != curRow) {
			$("#" + panel + " #manif-" + currentManif[panelId]).html("");
			$("#" + panel + " #depbut-" + currentManif[panelId]).text("Show");
		}
		
		currentManif[panelId] = curRow;
		
		if ($("#" + panel + " #depbut-" + currentManif[panelId]).text() == "Show") {
			$("#" + panel + " #manif-" + currentManif[panelId]).html( toManifestDetails(currentManif[panelId], 'DEP', currentRun) );
			$("#" + panel + " #depbut-" + currentManif[panelId]).text("Hide");
		} else {
			$("#" + panel + " #manif-" + currentManif[panelId]).html("");
			$("#" + panel + " #depbut-" + currentManif[panelId]).text("Show");
		}

		return;

	} else if (currentDetailsDiv.indexOf("de-it-souman-") > 0 ) {
		panel = thiss.parents('.content').attr('id');
		panelId = panel.substring(5);
		curRow = currentDetailsDiv.substring("de-it-souman-".length + 1);
		if(currentSourceManif[panelId] != -1 && currentSourceManif[panelId] != curRow) {
			$("#" + panel + " #sou-" + currentSourceManif[panelId]).html("");
			$("#" + panel + " #soubut-" + currentSourceManif[panelId]).text("Show");
		}
		
		currentSourceManif[panelId] = curRow;

		if ($("#" + panel + " #soubut-" + currentSourceManif[panelId]).text() == "Show") {
			$("#" + panel + " #sou-" + currentSourceManif[panelId]).html( toManifestDetails(currentSourceManif[panelId], 'SOU', currentRun) );
			$("#" + panel + " #soubut-" + currentSourceManif[panelId]).text("Hide");
		} else {
			$("#" + panel + " #sou-" + currentSourceManif[panelId]).html("");
			$("#" + panel + " #soubut-" + currentSourceManif[panelId]).text("Show");
		}
		
		return;
	}
		
	text = thiss.text();
	index = text.lastIndexOf(".");
	if(index > 0) {
		text = text.substring(index+1);
	}
	$("#panel" + panel + "Strong").text(text);
	
	if (currentDetailsDiv.indexOf("de-it-jp") > 0 ||
		currentDetailsDiv.indexOf("de-it-pu") > 0 ||
		currentDetailsDiv.indexOf("de-it-ge") > 0 ||
		key == 'xen') {
		$("#panel" + panel + "HeaderImage").attr("src", "resources/java.png");
	} else if (currentDetailsDiv.indexOf("de-it-do") > 0 || key == 'xdo' || currentDetailsDiv.indexOf("de-it-dd") > 0) {
		$("#panel" + panel + "HeaderImage").attr("src", "resources/business.png");
	} else if (currentDetailsDiv.indexOf("de-it-db") > 0 || key == 'xta' || currentDetailsDiv.indexOf("de-it-seq") > 0) {
		$("#panel" + panel + "HeaderImage").attr("src", "resources/db.png");
	} else if (currentDetailsDiv.indexOf("de-it-di") > 0) {
		$("#panel" + panel + "HeaderImage").attr("src", "resources/mapp.png");
	}
}

function getCursorPos(e, panel) {
    e = e || window.event;
	img = $("#panel" + panel + " svg")[0];
    /* Calculate the cursor's x and y coordinates, relative to the image: */
	a = img.getBoundingClientRect();
    x = e.pageX - a.left - window.pageXOffset;
    y = e.pageY - a.top - window.pageYOffset;
    return {x : x, y : y};
}

function middleSvg(panel) {
	img = $("#panel" + panel + " svg")[0];
	a = img.getBoundingClientRect();
    x = a.width / 2;
    y = a.height / 2;
	
	scrolling = scrollPart($("#panel" + panel));
	x -= scrolling.x;
	y -= scrolling.y;
	return {x : x, y : y};
}

// Resize and transform the content
function resizeImage(x,y, panel) {
	pn = panel - 1;
  	var newx = x - scaleFactor[pn] * x;
  	var newy = y - scaleFactor[pn] * y;

  	var tx = "translate(" + newx + "," + newy + "),scale(" + scaleFactor[pn] + "," + scaleFactor[pn] +")";
  	$("#panel" + panel + " .gcrop")[0].setAttribute("transform", tx);
}

function rescaleImage(panel, factor) {
	pn = panel - 1;
	stroke = $("#panel" + panel + " .rectRect").css("stroke-width").slice(0, -2) * factor;
	$("#panel" + panel + " .rectRect").css("stroke-width", stroke);
	
	circlesRadius[pn] = circlesRadius[pn] * factor;
	$("#panel" + panel + " #topLeft").attr("r", circlesRadius[pn]);
	$("#panel" + panel + " #topRight").attr("r", circlesRadius[pn]);
	$("#panel" + panel + " #botLeft").attr("r", circlesRadius[pn]);
	$("#panel" + panel + " #botRight").attr("r", circlesRadius[pn]);

	
	x = parseFloat($("#panel" + panel + " .clipRect").attr("x"));
	y = parseFloat($("#panel" + panel + " .clipRect").attr("y"));
	w = parseFloat($("#panel" + panel + " .clipRect").attr("width"));
	h = parseFloat($("#panel" + panel + " .clipRect").attr("height"));
	
	midx = x + w/2;
	midy = y + h/2;
	newW = w * factor;
	newH = h * factor;
	newx = midx - newW/2;
	newy = midy - newH/2;
	
	cropPlaceRect(panel, newx, newy, newW, newH);
	resizeImage(midx, midy, panel);
}

function hideRect(panel, id) {
	showCrop[panel] = 0;
	$("#" + id + " .gcrop").hide();
	$("#" + id + " .zoomP2").css("visibility", "hidden");
	$("#" + id + " .crop").css ("background-color","");
}

function changeIds(panel, suffix) {
	cropId = $("#panel" + panel + " defs clipPath").attr("class") + panel + suffix;
	$("#panel" + panel + " defs clipPath").attr("id", cropId);
	$("#panel" + panel + " #cropuse").attr("clip-path", "url(#" + cropId + ")");
	
	svgid = $("#panel" + panel + " svg").attr("id");
	$("#panel" + panel + " svg").attr("id", suffix + svgid);
	gid = "g-" + svgid + panel + suffix;
	$("#panel" + panel + " #cropuse").attr("href", "#" + gid);
	$("#panel" + panel + " .draggable").attr("id", gid);
}

function cropInitRectangle(panel) {
	// https://jsfiddle.net/docf1t40/2/
	changeIds(panel, '');

	rect = $("#panel" + panel + " .maskRect");
	w = parseInt(rect.attr("width"));
	h = parseInt(rect.attr("height"));
	mid = middleSvg(panel);

	x = mid.x - w/2;
	y = mid.y - h/2;

	cropPlaceRect(panel, x, y, w, h);
	resizeImage(mid.x, mid.y, panel);
	
	$("#panel" + panel + " .gcrop")[0].addEventListener("mousedown",function(evt){
		cropStartMove(evt, panel);	
	}, false);
}

function cropStartMove(evt, panel) {
	cropAction = evt.target.id;
	mouseMoveSelect = 2;
	cropStartMousePos = getCursorPos(evt, panel);
	
	oldX = parseFloat($("#panel" + panel + " .rectRect").attr("x"));
	oldY = parseFloat($("#panel" + panel + " .rectRect").attr("y"));
	rectWidth =  parseFloat($("#panel" + panel + " .rectRect").attr("width"));
	rectHeight =  parseFloat($("#panel" + panel + " .rectRect").attr("height"));
}

function cropMove(evt, panel) {
  	if(mouseMoveSelect != 2) return;

	switch(cropAction) {
		case "topLeft":
		case "topRight":
		case "botLeft":
		case "botRight":
			cropResize(evt, panel);		
			break;
		default:
			pos = getCursorPos(evt, panel);
	
			transX = oldX + pos.x - cropStartMousePos.x;
			transY = oldY + pos.y - cropStartMousePos.y;
			w = parseInt($("#panel" + panel + " .rectRect").attr("width"));
			h = parseInt($("#panel" + panel + " .rectRect").attr("height"));
			cropPlaceRect(panel, transX, transY, w, h);
			resizeImage(transX + w/2, transY + h/2, panel);
	}
}

function cropPlaceRect(panel, x, y, w, h) {
	$("#panel" + panel + " .clipRect").attr("x", x);
	$("#panel" + panel + " .clipRect").attr("y", y);
	$("#panel" + panel + " .rectRect").attr("x", x);
	$("#panel" + panel + " .rectRect").attr("y", y);
	$("#panel" + panel + " .maskRect").attr("x", x);
	$("#panel" + panel + " .maskRect").attr("y", y);

	$("#panel" + panel + " #topLeft").attr("cx", x);
	$("#panel" + panel + " #topLeft").attr("cy", y);
	$("#panel" + panel + " #topRight").attr("cx", x + w);
	$("#panel" + panel + " #topRight").attr("cy", y);
	$("#panel" + panel + " #botLeft").attr("cx", x);
	$("#panel" + panel + " #botLeft").attr("cy", y + h);
	$("#panel" + panel + " #botRight").attr("cx", x + w);
	$("#panel" + panel + " #botRight").attr("cy", y + h);
	
	$("#panel" + panel + " .clipRect").attr("width", w);
	$("#panel" + panel + " .clipRect").attr("height", h);
	$("#panel" + panel + " .maskRect").attr("width", w);
	$("#panel" + panel + " .maskRect").attr("height", h);
	$("#panel" + panel + " .rectRect").attr("width", w);
	$("#panel" + panel + " .rectRect").attr("height", h);
	
}

function cropReset(panel) {
	$("#panel" + panel + " .rectRect").css("stroke-width", "1px");
	$("#panel" + panel + " #topLeft").attr("r", circlesRadiusConstant);
	$("#panel" + panel + " #topRight").attr("r", circlesRadiusConstant);
	$("#panel" + panel + " #botLeft").attr("r", circlesRadiusConstant);
	$("#panel" + panel + " #botRight").attr("r", circlesRadiusConstant);
	cropPlaceRect(panel, rectXConstant, rectYConstant, rectWidthConstant, rectHeightConstant);
}

function cropResize(evt, panel) {
	var newW, newH, newX, newY;
	
	pos = getCursorPos(evt, panel);
	transX = (pos.x - cropStartMousePos.x) / scaleFactor[panel-1];
	transY = (pos.y - cropStartMousePos.y) / scaleFactor[panel-1];
	min = 10 / scaleFactor[panel-1];
	
	switch (cropAction) {
		case "topLeft":
			newW = Math.max(min, rectWidth - transX);
			newH = Math.max(min, rectHeight - transY);
			newX = Math.min(oldX + rectWidth - min, oldX + transX);
			newY = Math.min(oldY + rectHeight - min, oldY + transY);
			break;
		
		case "topRight":
			newW = Math.max(min, rectWidth + transX);
			newH = Math.max(min, rectHeight - transY);
			newX = oldX;
			newY = Math.min(oldY + rectHeight - min, oldY + transY);
			break;
		
		case "botLeft":
			newW = Math.max(min, rectWidth - transX);
			newH = Math.max(min, rectHeight + transY);
			newX = Math.min(oldX + rectWidth - min, oldX + transX);
			newY = oldY;
			break;
		
		case "botRight":
			newW = Math.max(min, rectWidth + transX);
			newH = Math.max(min, rectHeight + transY);
			newX = oldX;
			newY = oldY;
			break;
    }

	cropPlaceRect(panel, newX, newY, newW, newH);
}

 function makeImage() {
   var canvas = document.getElementById("canvas");
   var img = new Image();
    var jpg = canvas.toDataURL("image/jpeg", 1.0);
    document.querySelector('#panel2').innerHTML = '<img width="500" height="600" src="'+jpg+'"/>';
   console.log('image constructed');
 }
