$(document).ready(function(){
	$("#con-java").toggle();
	
	detailsMaxHeight = $(".container").height() - 84;
	$("#details").css("max-height", detailsMaxHeight);
	$("#itemType").css("max-height", detailsMaxHeight);
	$("#details").css("height", 400);
	
	itemsMaxWidth = $(".container").width() - 7;
	$(".col1").css("max-width", itemsMaxWidth);
	
	selectedItem = $("#aboutPopup"); 
	
	init();
	$("#details .zoom").hide();
	$("#graph .zoom").hide();
	$("#graph .svgcrop").hide();
	$("#details .svgcrop").hide();
	$(".zoomP2").css("visibility", "hidden");
	$(".zoomP3").css("visibility", "hidden");
	
	if (showSuperclassAttributes == false) {
		$(".superClass").hide();
	}
	
	if (showCountsAttribute == false) {
		$(".showCounts").hide();
	}
	
	$("body").click(function() {
		if ($("#panel1" + " > svg").length) {
			$("#details .zoom").show();
			if (typeof(isPremium) == 'undefined') {
				$("#details .svgcrop").hide();
			} else {
				if ($("#panel1" + " svg").attr("id").startsWith("x")) {
					$("#details .svgcrop").show();
				} else {
					$("#details .svgcrop").hide();
				}
			}
			
		} else {
			$("#details .zoom").hide();
			$("#details .svgcrop").hide();
			$("#details .zoomP2").css("visibility", "hidden");
			$("#details .zoomP3").css("visibility", "hidden");
		}
		
		if ($("#panel2" + " > svg").length) {
			$("#graph .zoom").show();
			if (typeof(isPremium) == 'undefined') {
				$("#graph .svgcrop").hide();
			} else {
				if ($("#panel2" + " svg").attr("id").startsWith("x")) {
					$("#graph .svgcrop").show();
				} else {
					$("#graph .svgcrop").hide();
				}
			}

		} else {
			$("#graph .zoomP2").css("visibility", "hidden");
			$("#graph .zoom").hide();
			$("#graph .svgcrop").hide();
			$("#graph .zoomP3").css("visibility", "hidden");
		}
	});
	
	$("body").mouseup(function() {
		mouseMoveSelect = 0;
	});
	
    $(".max").click(function() {
		id = $(this).parent().parent().attr("id");

		var newHeight;
		if ($(this).parent().parent().hasClass("fullColElem")) {
			$("#details").css("max-height", detailsMaxHeight);
			
			newHeight = detailsHeight; 
			$(".max").attr("title", "Maximize");
		} else {
			$("#details").css("max-height", '');
			
			detailsHeight = $("#details").css("height");
			newHeight = "100%"; 
			$(".max").attr("title", "Restore");
		}

		$(".splitter").toggle();
		$("#items").toggle();
		$("#itemType").toggle();
		if (id == 'details') {
			$("#graph").toggle();
			$("#details").css("height", newHeight);
		} else {
			$("#details").toggle();
		}

		$(this).parent().parent().parent().toggleClass("col2");
		$(this).parent().parent().parent().toggleClass("fullCol");
		$(this).parent().parent().toggleClass("fullColElem");
		$(this).toggleClass("fullMax");
    });	

	$(window).resize(function() {
		detailsMaxHeight = $(".container").height() - 84;
		if (!$("#details").hasClass("fullColElem") ) {
			$("#details").css("max-height", detailsMaxHeight);
		}
		$("#itemType").css("max-height", detailsMaxHeight);
		
		itemsMaxWidth = $(".container").width() - 7;
		$(".col1").css("max-width", itemsMaxWidth);
	});

	$(".col2").on('click', '.popup', function(){
		id = $(this).attr("data-id");
		idArray = id.split("|");
		if(idArray.length > 1) {
			title = "Description " + idArray[0];
			dsId = idArray[1];
			doc = MAP[currentRun]['ds' + dsId];
			
			if(dsId.startsWith("html")) {
				dsId = dsId.substring(4);
				doc = '<div style="white-space: pre;">' + MAP[currentRun]['ds' + dsId] + '</div>';
			}
			
			if (longDescriptionTarget == 'POPUP') {
				$("#descrPopup").html(doc);
				$("#descrPopup").dialog({
					title: title,
					width: 500,
					maxHeight: $( window ).height() - 150
				});
			} else {
				$("#panel2").html(doc);
				$("#panel2Strong").text(title);
				$("#panel2HeaderImage").attr("src", "resources/text.png");
			}
		}
	});	

	$(".col2").on('mousemove', '#panel1', function(evt) {
		switch (mouseMoveSelect) {
			case 1:
				drag(evt, 1);
				break;
			case 2:
				cropMove(evt, 1);
				break;
		}
	});

	$(".col2").on('mousemove', '#panel2', function(evt) {
		switch (mouseMoveSelect) {
			case 1:
				drag(evt, 2);
				break;
			case 2:
				cropMove(evt, 2);
				break;
		}
	});

	$(".col2").on('click', '.zoomP2', function(event) {
		id = $(this).parents("div.colElem:first").attr("id");
		var panel = 1;
		targetId = 'graph';
		
		if(id == 'graph') {
			panel = 2;
			targetId = 'details';
		}
		pn = panel - 1;
		targetPanel = (event.altKey ? 2 : 1);
		targetId = (event.altKey ? 'graph' : 'details');
		
		if($(this).hasClass("scaleup")) {
			factor = scaleFactor[pn] / (scaleFactor[pn] + 0.5);
			scaleFactor[pn] = scaleFactor[pn] + 0.5;
			rescaleImage(panel, factor);
			return;
				
		} else if($(this).hasClass("scaledown")) {
			newScaleFactor = scaleFactor[pn] - 0.5;
			if (newScaleFactor < 1) {
				newScaleFactor = 1;
			}
			
			factor = scaleFactor[pn] / newScaleFactor ;
			scaleFactor[pn] = newScaleFactor;
			rescaleImage(panel, factor);
			return;
		}
		
		svg1 = $("#panel" + panel).html();
		$("#panel" + targetPanel).html( svg1 );
		svg2 = $("#panel" + targetPanel + " svg");
		changeIds(targetPanel, 'cropped');
		svg2.css("clip-path", "url(#" +  $("#panel" + targetPanel + " defs clipPath").attr("id") + ")");
		hideRect(targetPanel, targetId);
		scrollToMiddle("panel" + targetPanel);
		
		svgWidth = parseInt( svg2.attr("width").slice(0, -2) );
		rectWidth = parseInt( $("#panel" + targetPanel + " defs rect").attr("width") );
		rectX = parseInt( $("#panel" + targetPanel + " defs rect").attr("x") );
		diffW = parseInt(svgWidth/2 - (rectX + rectWidth/2) );
		scroll = $("#panel" + targetPanel).scrollLeft();
		$("#panel" + targetPanel).scrollLeft(scroll - diffW);

		svgHeight = parseInt( svg2.attr("height").slice(0, -2) );
		rectHeight = parseInt( $("#panel" + targetPanel + " defs rect").attr("height") );
		rectY = parseInt( $("#panel" + targetPanel + " defs rect").attr("y") );
		diffH = parseInt(svgHeight/2 - (rectY + rectHeight/2) );
		scroll = $("#panel" + targetPanel).scrollTop();
		$("#panel" + targetPanel).scrollTop(scroll - diffH);

		croppedInit(panel, targetPanel);
		isCropped = true;
		$("#" + targetId + " .zoomP3").css("visibility", "visible");
	});		

	$(".col2").on('click', '.save', function(event) {
		id = $(this).parents("div.colElem:first").attr("id");
		var panel = 1;
		if(id == 'graph') {
			panel = 2;
		}

		svg = $("#panel" + panel + " svg");
		data = $("#panel" + panel).html();
		const svgBlob = new Blob([data], {
    		type: 'image/svg+xml;charset=utf-8'
		});
		
		const url = URL.createObjectURL(svgBlob);
		const img = new Image();
		img.addEventListener('load', () => {
			svgWidth = parseInt( svg.attr("width").slice(0, -2) );
			svgHeight = parseInt( svg.attr("height").slice(0, -2) );
			
  			const canvas = document.createElement('canvas');
  			canvas.width = svgWidth;
  			canvas.height = svgHeight;

  			const context = canvas.getContext('2d');
			context.drawImage(img, 0, 0, svgWidth, svgHeight);

  			URL.revokeObjectURL(url);

  			// trigger a synthetic download operation with a temporary link
  			const a = document.createElement('a');
			filename = document.getElementById("filename" + panel).value;
  			a.download = filename;
  			document.body.appendChild(a);
  			a.href = canvas.toDataURL();
  			a.click();
  			a.remove();
		});
		img.src = url;
		
	});

	$(".col2").on('click', '.zoom', function() {
		id = $(this).parents("div.colElem:first").attr("id");
		var panel = 0;
		if(id == 'graph') {
			panel = 1;
		}
		
		sliderValue[panel] = 20;
		if(panel == 0) {
			$( "#z01s" ).slider( "option", "value", sliderValue[panel] );
		} else {
			$( "#z02s" ).slider( "option", "value", sliderValue[panel] );
		}

		if($(this).hasClass("zoom-out")) {
			zoom(panel, 0.5, true);
		} else if($(this).hasClass("zoom-in")) {
			zoom(panel, 2, true);
		} else {
			if(isCropped) return;
			initSvg(panel + 1);
			scrollVertical($("#panel" + (panel + 1)));
			scrollHorizontal($("#panel" + (panel + 1)));
		}
	});

	$(".col2").on('click', '.svgcrop', function() {
		id = $(this).parents("div.colElem:first").attr("id");
		var panel = 0;
		if(id == 'graph') {
			panel = 1;
		}
		
		if($(this).hasClass("crop")) {
			if(showCrop[panel]) {
				hideRect(panel, id);
			} else {
				showCrop[panel] = 1;
				cropInitRectangle(panel + 1);
				$("#" + id + " .zoomP2").css("visibility", "visible");
				$("#" + id + " .gcrop").show();
				$("#" + id + " .crop").css ("background-color","#372B37");
			}	

		} else {
			initSvg(panel + 1);
			scrollVertical($("#panel" + (panel + 1)));
			scrollHorizontal($("#panel" + (panel + 1)));
		}
	});

	$(".col2").on('click', '.popup2', function() {
		if(issueType == "Issue Report") {
			errObj = APP[currentRun].er[$(this).attr("data-id").substring(3)];
		} else {
			errObj = APP[currentRun].eri[$(this).attr("data-id").substring(3)];
		}
		erdObj = APP[currentRun].erd['a' + errObj.id];
		
		html = $('#popup2dialog').html();
		
		pos1 = html.indexOf('ppd1') + 6;
		pos2 = html.indexOf('</span>', pos1);
		html = html.substring(0, pos1) + erdObj.na + html.substring(pos2);
		
		pos1 = html.indexOf('ppd2') + 6;
		pos2 = html.indexOf('</span>', pos1);
		html = html.substring(0, pos1) + errObj.nr + html.substring(pos2);
		
		message = errObj.te;
		refLinks = "";
		
		j = 0;
		Object.keys(errObj.pa).forEach(function(key) {
			message = message.replace("{" + j + "}", key);
			refLinks += '<li><a class="link link1" data-id="it-' + errObj.pa[key].substring(0, 2) + '-' + errObj.pa[key].substring(2) + '">' 
				+ key + '</a></li>';
			j++;
		});
		
		pos1 = html.indexOf('ppd3') + 6;
		pos2 = html.indexOf('</span>', pos1);
		html = html.substring(0, pos1) + message + html.substring(pos2);
		
		references = "";
		if(refLinks.length > 0) {
			references = "<p><h2>References</h2></p><ul>";
			references += refLinks;
			references += "</ul>";
		}

		pos1 = html.indexOf('ppd4') + 6;
		pos2 = html.indexOf('</span>', pos1);
		html = html.substring(0, pos1) + references + html.substring(pos2);

		pos1 = html.indexOf('ppd5') + 6;
		pos2 = html.indexOf('</span>', pos1);
		html = html.substring(0, pos1) + erdObj.de + html.substring(pos2);

		pos1 = html.indexOf('ppd6') + 6;
		pos2 = html.indexOf('</span>', pos1);
		html = html.substring(0, pos1) + erdObj.so + html.substring(pos2);
	
		pos1 = html.indexOf('ppd7') + 6;
		pos2 = html.indexOf('</span>', pos1);
		html = html.substring(0, pos1) + erdObj.le + html.substring(pos2);

		panel = $(this).parents("div.content:first").attr("id");

		pos1 = html.indexOf('data-id2="') + 10;
		pos2 = html.indexOf('"', pos1);
		html = html.substring(0, pos1) + panel + html.substring(pos2);
	
		if (longDescriptionTarget == 'POPUP') {
			$('#popup2dialog').html(html);
			$('#popup2dialog').dialog({
				width: 500
			});
		} else {
			$("#panel" + panel).html(html);
			$("#panel" + panel + "Strong").text("Error Explanation");
			$("#panel" + panel + "HeaderImage").attr("src", "resources/text.png");
		}
	});	
	
	$(".pertypes").click(function(event) {
		panel = (event.altKey ? 2 : 1);
	
		if ($(this).attr("id") == 't-application' ) {
			$("#panel" + panel).html(toApplicationDetails(currentRun));
			$("#panel" + panel + "Strong").text("Application " + APP[currentRun].name);
			$("#panel" + panel + "HeaderImage").attr("src", "resources/java.png");
			$(".itemsContent").html('');

		} else if ($(this).attr("id") == 't-database' ) {
			currentDetailsDiv = "#t-database-div";
			$("#panel" + panel).html(toDatabaseDetails(currentRun));
			$("#panel" + panel + "Strong").text("Database " + APP[currentRun].name);
			$("#panel" + panel + "HeaderImage").attr("src", "resources/db.png");
			$(".itemsContent").html('');

		} else if ($(this).attr("id") == 't-tables' ) {
			$(".itemsContent").html(tablesList);
		} else if ($(this).attr("id") == 't-views' ) {
			$(".itemsContent").html(viewsList);
		} else if ($(this).attr("id") == 't-seq' ) {
			$(".itemsContent").html(seqList);
		} else if ($(this).attr("id") == 't-allDatabase' ) {
			$(".itemsContent").html(allDbList);
		} else if ($(this).attr("id") == 't-allJava' ) {
			$(".itemsContent").html(allJpaList);
		} else if ($(this).attr("id") == 't-entities' ) {
			$(".itemsContent").html(entsList);
		} else if ($(this).attr("id") == 't-embeddables' ) {
			$(".itemsContent").html(embedsList);
		} else if ($(this).attr("id") == 't-mappedSuperclasses' ) {
			$(".itemsContent").html(supersList);
		} else if ($(this).attr("id") == 't-idgen' ) {
			$(".itemsContent").html(idgenList);
		} else if ($(this).attr("id") == 't-enums' ) {
			$(".itemsContent").html(enumsList);
		} else if ($(this).attr("id") == 't-allDomain' ) {
			$(".itemsContent").html(domainObjectsList);
		} else if ($(this).attr("id") == 't-domain' ) {
			$(".itemsContent").html(domainsList);
		} else if ($(this).attr("id") == 't-pus' ) {
			$(".itemsContent").html(pusList);
		} else if ($(this).attr("id") == 't-allDiagrams' ) {
			$(".itemsContent").html(diagramsList);
		}
		
		$("#itemsStrong").text($(this).text());
		selectedItemType.toggleClass("active");
		selectedItemType = $(this);
		$(this).toggleClass("active");
	})
	
	$(".col1").on('click', '.peritems', function(event) {
		panel = (event.altKey ? 2 : 1);
		linkIt($(this), panel, "#de-" + $(this).attr("id"));
		
		selectedItem.toggleClass("active");
		selectedItem = $(this);
		$(this).toggleClass("active");
	})
	
	$(".col1").resizableSafe({
    	handleSelector: ".splitterH",
    	resizeHeight: false
	});

	$("#itemType").resizableSafe({
    	handleSelector: "#splV1",
    	resizeWidth: false
	});

	$("#details").resizableSafe({
    	handleSelector: "#splV2",
    	resizeWidth: false
	});

	$(".col2").on('click', '.link_ignoredErrors', function(event) {
		if(issueType == "Issue Report") {
			issueType = "Ignored Issues";
		} else {
			issueType = "Issue Report";
		}
		errorReport(event);
	});

	$(".col2").on('click', '.link1', function(event) {
		panel = (event.altKey ? 2 : 1);
		
		linkIt($(this), panel, "#de-" + $(this).attr("data-id"));
	});

	$("#popup2dialog").on('click', '.link1', function(event) {
		panel = (event.altKey ? 2 : 1);
		linkIt($(this), panel, "#de-" + $(this).attr("data-id"));
	});
	
	$(".col2").on('click', '.jpa2dblink', function(event) {
		panel = (event.altKey ? 2 : 1);
		$(".jpa2dblink").parents("tr").removeClass("linked");
		$(".jpa2dblink").parents("tr").addClass("gradient");
		$(".jpa2domlink").parents("tr").removeClass("linked");
		$(".jpa2domlink").parents("tr").addClass("gradient");

		$(this).parents("tr").toggleClass("linked");
		$(this).parents("tr").toggleClass("gradient");

		arrString = $(this).parents("tr").attr("data-columns");
		arrObj = JSON.parse(arrString);
		id = arrObj[0].ti;
		$("#panel" + panel).html( toHtmlDbDetails(id, currentRun) );

		for (i = 0; i < arrObj.length; i++) {
			var elem = $("#" + arrObj[i].ci);
			elem.toggleClass("linked");
			elem.toggleClass("gradient");
		}
		
		db = MAP[currentRun]['db' + id];
		$("#panel" + panel + "Strong").text(db.na);
		$("#panel" + panel + "HeaderImage").attr("src", "resources/db.png");

		var elem = $("#" + arrObj[0].ci),
    	container = $('#panel' + panel),
    	pos = elem.position().top + container.scrollTop() - container.position().top;

		container.animate({
  			scrollTop: pos
		});
	});

	$(".col2").on('click', '.jpa2domlink', function(event) {
		panel = (event.altKey ? 2 : 1);
		id = $(this).parents("tr").attr("data-jClass");
		$("#panel" + panel).html( toHtmlDoDetails(id, currentRun) );
		
		$(".jpa2dblink").parents("tr").removeClass("linked");
		$(".jpa2dblink").parents("tr").addClass("gradient");
		$(".jpa2domlink").parents("tr").removeClass("linked");
		$(".jpa2domlink").parents("tr").addClass("gradient");

		$(this).parents("tr").toggleClass("linked");
		$(this).parents("tr").toggleClass("gradient");

		$("#panel" + panel + " ." + $(this).parents("tr").attr("data-attr")).toggleClass("linked");
		$("#panel" + panel + " ." + $(this).parents("tr").attr("data-attr")).toggleClass("gradient");
		
		jpa = MAP[currentRun]['jp' + id][0];
		$("#panel" + panel + "Strong").text( shortName(jpa.na).toUpperCase());
		$("#panel" + panel + "HeaderImage").attr("src", "resources/business.png");

		var elem = $("#panel" + panel + " ." + $(this).parents("tr").attr("data-attr")),
    	container = $('#panel' + panel),
    	pos = elem.position().top + container.scrollTop() - container.position().top;

		container.animate({
  			scrollTop: pos
		});
	});

	$(".col2").on('click', '.dom2jpalink', function(event) {
		panel = (event.altKey ? 2 : 1);
		id = $(this).parents("tr").attr("data-jClass");
		$("#panel" + panel).html( toHtmlJpaDetails(id, panel, currentRun) );
		
		$(".dom2dblink").parents("tr").removeClass("linked");
		$(".dom2dblink").parents("tr").addClass("gradient");
		$(".dom2jpalink").parents("tr").removeClass("linked");
		$(".dom2jpalink").parents("tr").addClass("gradient");

		$(this).parents("tr").toggleClass("linked");
		$(this).parents("tr").toggleClass("gradient");

		var str = "#panel" + panel + " ";
		if(activeTab != -1) {
			str = '#tabs-' + activeTab + ' ';
		}

		attId = $(this).parents("tr").attr("data-attr");
		$(str + "." + attId).toggleClass("linked");
		$(str + "." + attId).toggleClass("gradient");
		
		jpa = MAP[currentRun]['jp' + hashId(id)][0];
		$("#panel" + panel + "Strong").text( shortName(jpa.na) );
		$("#panel" + panel + "HeaderImage").attr("src", "resources/java.png");

		$('#panel' + panel).animate({
   			scrollTop: $(str + "." + attId).offset().top - $('#panel' + panel).offset().top + $('#panel' + panel).scrollTop()
		}, 'fast');
	});

	$(".col2").on('click', '.dom2dblink', function(event) {
		panel = (event.altKey ? 2 : 1);

		$(".dom2dblink").parents("tr").removeClass("linked");
		$(".dom2dblink").parents("tr").addClass("gradient");
		$(".dom2jpalink").parents("tr").removeClass("linked");
		$(".dom2jpalink").parents("tr").addClass("gradient");

		$(this).parents("tr").toggleClass("linked");
		$(this).parents("tr").toggleClass("gradient");

		arrString = $(this).parents("tr").attr("data-columns");
		arrObj = JSON.parse(arrString);
		id = arrObj[0].ti;
		$("#panel" + panel).html( toHtmlDbDetails(id, currentRun) );

		for (i = 0; i < arrObj.length; i++) {
			var elem = $("#" + arrObj[i].ci);
			elem.toggleClass("linked");
			elem.toggleClass("gradient");
		}
		
		db = MAP[currentRun]['db' + id];
		$("#panel" + panel + "Strong").text(db.na);
		$("#panel" + panel + "HeaderImage").attr("src", "resources/db.png");

		var elem = $("#" + arrObj[0].ci),
    	container = $('#panel' + panel),
    	pos = elem.position().top + container.scrollTop() - container.position().top;

		container.animate({
  			scrollTop: pos
		});
	});

	$(".col2").on('click', '.db2jpalink', function(event) {
		panel = (event.altKey ? 2 : 1);
		$(".db2domlink").parents("tr").removeClass("linked");
		$(".db2domlink").parents("tr").addClass("gradient");
		$(".db2jpalink").parents("tr").removeClass("linked");
		$(".db2jpalink").parents("tr").addClass("gradient");

		$(this).parents("tr").toggleClass("linked");
		$(this).parents("tr").toggleClass("gradient");

		arrString = $(this).parents("tr").attr("data-jpalink");
		arrObj = JSON.parse(arrString);
		if(arrObj.length > 1) {
			arrayObject = arrObj;
			db2jpalinkMultiple(arrObj, panel);
			return;
		}
		
		highlightJpa(arrObj[0], arrObj[0].li[0].ci, panel);
	});
	
	$(".col2").on('click', '.db2domlink', function(event) {
		panel = (event.altKey ? 2 : 1);
	
		$(".db2domlink").parents("tr").removeClass("linked");
		$(".db2domlink").parents("tr").addClass("gradient");
		$(".db2jpalink").parents("tr").removeClass("linked");
		$(".db2jpalink").parents("tr").addClass("gradient");

		$(this).parents("tr").toggleClass("linked");
		$(this).parents("tr").toggleClass("gradient");

		arrString = $(this).parents("tr").attr("data-jpalink");
		arrObj = JSON.parse(arrString);
		if(arrObj.length > 1) {
			arrayObject = arrObj;
			db2domlinkMultiple(arrObj, panel);
			return;
		}
		
		highlightDom(arrObj[0], arrObj[0].li[0].ci, panel);
	});
	
	
	$(".col2").on('click', '.plusminus', function(){
		id = $(this).attr("data-klapp");
		text = $(this).text();
		if (text == '\u229E') {
			$(".topshow-" + id).html("&boxminus;");
			$(".show-" + id).show();
		} else if (text == '\u229F') {
			$(".tophide-" + id).html("&plusb;");
			$(".hide-" + id).hide();
		}
	})

	$("#notLinkedPopup").on('click', '.dialink', function(){
		id = $(this).attr('data-dialink');
		$("#notLinkedPopup").dialog("close");

		idhc = hashId(id);
		var theobj;
		for(let obj of arrayObject) {
			hc = hashId(obj.id);
			if(hc == idhc) {
				theobj = obj;
				break;
			}		
		}

		panel = $("#notLinkedPopup > #panelnbr").attr("data-id");
		type = $('#notLinkedPopupType').val();
		if(type == 'jpa') {
			highlightJpa(theobj, id, panel);
		} else {
			highlightDom(theobj, id, panel);
		}
	});

});

